/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-pr2-image-snapshot-recorder-1.0.21-0precise-20150329-2039/obj-x86_64-linux-gnu/devel/share/pr2_image_snapshot_recorder/msg/ImageSnapshotGoal.msg
 *
 */


#ifndef PR2_IMAGE_SNAPSHOT_RECORDER_MESSAGE_IMAGESNAPSHOTGOAL_H
#define PR2_IMAGE_SNAPSHOT_RECORDER_MESSAGE_IMAGESNAPSHOTGOAL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace pr2_image_snapshot_recorder
{
template <class ContainerAllocator>
struct ImageSnapshotGoal_
{
  typedef ImageSnapshotGoal_<ContainerAllocator> Type;

  ImageSnapshotGoal_()
    : topic_name()
    , num_images(0)
    , output_file_name()  {
    }
  ImageSnapshotGoal_(const ContainerAllocator& _alloc)
    : topic_name(_alloc)
    , num_images(0)
    , output_file_name(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _topic_name_type;
  _topic_name_type topic_name;

   typedef int32_t _num_images_type;
  _num_images_type num_images;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _output_file_name_type;
  _output_file_name_type output_file_name;




  typedef boost::shared_ptr< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ImageSnapshotGoal_

typedef ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<std::allocator<void> > ImageSnapshotGoal;

typedef boost::shared_ptr< ::pr2_image_snapshot_recorder::ImageSnapshotGoal > ImageSnapshotGoalPtr;
typedef boost::shared_ptr< ::pr2_image_snapshot_recorder::ImageSnapshotGoal const> ImageSnapshotGoalConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace pr2_image_snapshot_recorder

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'pr2_image_snapshot_recorder': ['/tmp/buildd/ros-hydro-pr2-image-snapshot-recorder-1.0.21-0precise-20150329-2039/obj-x86_64-linux-gnu/devel/share/pr2_image_snapshot_recorder/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "13e4842bc6386877d90e53523f6d94ba";
  }

  static const char* value(const ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x13e4842bc6386877ULL;
  static const uint64_t static_value2 = 0xd90e53523f6d94baULL;
};

template<class ContainerAllocator>
struct DataType< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "pr2_image_snapshot_recorder/ImageSnapshotGoal";
  }

  static const char* value(const ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
string topic_name # Topic name, must be of sensor_msgs/Image\n\
int32 num_images # Set <0 to record until prempted\n\
string output_file_name # Default: /hwlog/TOPIC_NAME_DATE_TIME.bag\n\
";
  }

  static const char* value(const ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.topic_name);
      stream.next(m.num_images);
      stream.next(m.output_file_name);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ImageSnapshotGoal_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::pr2_image_snapshot_recorder::ImageSnapshotGoal_<ContainerAllocator>& v)
  {
    s << indent << "topic_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.topic_name);
    s << indent << "num_images: ";
    Printer<int32_t>::stream(s, indent + "  ", v.num_images);
    s << indent << "output_file_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.output_file_name);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PR2_IMAGE_SNAPSHOT_RECORDER_MESSAGE_IMAGESNAPSHOTGOAL_H
